package implementation;

import java.util.List;

/**
 * Ein Modell des Holzpuzzles der Matse Spass AG.
 * Es hat Einzelteile, die zu einem glatten Quader zusammengesteckt werden sollen.
 * Zudem hat es eine Beschreibung.
 */
public class HolzPuzzle {
	//Attribute
private List<Wuerfel> teile;
private Wuerfel[][][] quader;
private List<String> kommentare;

	/**
	 * Erzeugt ein neues Holzpuzzle
	 * @param teile Einzelteile des Puzzles
	 * @param quader Flaeche fuer das Puzzle
	 * @param kommentare Beschreibung des Puzzles
	 */
	public HolzPuzzle(List<Wuerfel> teile, Wuerfel[][][] quader, List<String> kommentare){
		this.teile= teile;
		this.quader= quader;
		this.kommentare = kommentare;
	}

	/**
	 * Gibt die Beschreibung zurueck
	 * @return Beschreibung
	 */
	public List<String> getKommentare() {
		return kommentare;
	}

	/**
	 * Gibt die Einzelteile des Puzzles zurueck
	 * @return Einzelteile
	 */
	public List<Wuerfel> getTeile() {
		return teile;
	}

	/**
	 * Gibt die Form zurueck in die das Puzzle passen soll
	 * @return Quader
	 */
	public Wuerfel[][][] getQuader() {
		return quader;
	}
}
