package implementation;

import java.util.List;

public class Loesbarkeitspruefung {
	/**
	 * Ermittelt ob der Wuerfel anhand der bestimmten Klassen loesbar sein kann.
	 * Hier koennen erste Puzzle als unloesbar ausgeschlossen werden.
	 *
	 * @param klassen klassifizierte Wuerfel
	 * @return ist Loesbar
	 */
	public static boolean isSolvableRegardingClasses(HolzPuzzle holzPuzzle,List<Wuerfel>[] klassen) {
		int dimX = holzPuzzle.getQuader().length;
		int dimY = holzPuzzle.getQuader()[0].length;
		int dimZ = holzPuzzle.getQuader()[0][0].length;

		//1*1*1 Trivialfall, hier darf nur ein Wuerfel 6 Aussenflaechen haben
		if (dimX == 1 && dimY == 1 && dimZ == 1) {
			if (klassen[6].size() != 1) {
				return false;
			}
			//Zwei Dimensionen sind 1, also darf es nur zwei Enden geben
		} else if (((dimX * dimY == 1) || (dimY * dimZ == 1) || (dimX * dimZ == 1))) {
			if (klassen[6].size() != 0 || klassen[5].size() != 2) {
				return false;
			}
			//Eine Dimension betraegt 1, damit gibt es 4 Ecken
		} else if (((dimX == 1) || (dimY == 1) || (dimZ == 1))) {
			if (klassen[6].size() != 0 || klassen[5].size() != 0 || klassen[4].size() != 4) {
				return false;
			}
			//Hier ist ein echter Quader mit 8 Ecken
		} else if (klassen[6].size() != 0 || klassen[5].size() != 0 || klassen[4].size() != 0 ||
			klassen[3].size() != 8 || klassen[2].size() != 4 * (dimX + dimY + dimZ - 6)) {
			{
				return false;
			}
		}
		//Der Flaecheninhalt der Seiten des Quaders muss der Anzahl der aussenflaechen entsprechen
		int zaehlerAussen = 0;
		for (int i = 0; i < klassen.length; i++) {
			zaehlerAussen += i * klassen[i].size();
		}
		return 2 * (dimX * dimY + dimY * dimZ + dimX * dimZ) == zaehlerAussen;
	}
}
